intern-0.9.6: Efficient hash-consing for arbitrary data types

Safe Haskell | Safe-Inferred
Language | Haskell2010

Data.Interned.Internal.String

# Documentation

data InternedString Source #

Constructors

IS |

Fields

- internedStringId :: !Id
- uninternString :: String

#### Instances

Instances details

IsString InternedString Source # |
Instance details Defined in Data.Interned.Internal.String Methods fromString :: String -> InternedString Source #
Show InternedString Source # |
Instance details Defined in Data.Interned.Internal.String Methods showsPrec :: Int -> InternedString -> ShowS Source # show :: InternedString -> String Source # showList :: [InternedString] -> ShowS Source #
Eq InternedString Source # |
Instance details Defined in Data.Interned.Internal.String Methods (==) :: InternedString -> InternedString -> Bool Source # (/=) :: InternedString -> InternedString -> Bool Source #
Ord InternedString Source # |

Instance details

Defined in Data.Interned.Internal.String

Methods

compare :: InternedString -> InternedString -> Ordering Source #

(<) :: InternedString -> InternedString -> Bool Source #

(<=) :: InternedString -> InternedString -> Bool Source #

(>) :: InternedString -> InternedString -> Bool Source #

(>=) :: InternedString -> InternedString -> Bool Source #

max :: InternedString -> InternedString -> InternedString Source #

min :: InternedString -> InternedString -> InternedString Source #

Hashable InternedString Source # |
Instance details Defined in Data.Interned.Internal.String Methods hashWithSalt :: Int -> InternedString -> Int Source # hash :: InternedString -> Int Source #
Interned InternedString Source # |

Instance details

Defined in Data.Interned.Internal.String

Associated Types

data Description InternedString Source #

type Uninterned InternedString Source #

Methods

describe :: Uninterned InternedString -> Description InternedString Source #

identify :: Id -> Uninterned InternedString -> InternedString Source #

seedIdentity :: p InternedString -> Id Source #

cacheWidth :: p InternedString -> Int Source #

modifyAdvice :: IO InternedString -> IO InternedString Source #

cache :: Cache InternedString Source #

Uninternable InternedString Source # |
Instance details Defined in Data.Interned.Internal.String Methods unintern :: InternedString -> Uninterned InternedString Source #
Eq (Description InternedString) Source # |
Instance details Defined in Data.Interned.Internal.String Methods (==) :: Description InternedString -> Description InternedString -> Bool Source # (/=) :: Description InternedString -> Description InternedString -> Bool Source #
Hashable (Description InternedString) Source # |
Instance details Defined in Data.Interned.Internal.String Methods hashWithSalt :: Int -> Description InternedString -> Int Source # hash :: Description InternedString -> Int Source #
data Description InternedString Source # |

Instance details

Defined in Data.Interned.Internal.String

data Description InternedString

- = Cons !Char String
- | Nil

type Uninterned InternedString Source # |
Instance details Defined in Data.Interned.Internal.String type Uninterned InternedString = String